(*  Title:      ~~test/../ProgLang/calculate.thy
    Author:     Walther Neuper
*)

theory calculate
imports Isac.Build_Thydata
begin

text \<open>
  *setup* KEStore_Elems.add_pbls / add_mets is impossible in *.sml files.
  The respective test/../evaluate.sml is called in Test_Isac.thy.
\<close>

ML \<open>
"-calculate.thy: provides 'setup' -----------------------";
"-calculate.thy: provides 'setup' -----------------------";
"-calculate.thy: provides 'setup' -----------------------";
\<close>

setup \<open>KEStore_Elems.add_pbls @{context}
  [Problem.prep_input @{theory "Test"} "pbl_ttest" [] Problem.id_empty (["test"], [], Rule_Set.empty, NONE, []),
    Problem.prep_input @{theory "Test"} "pbl_ttest_calc" [] Problem.id_empty
      (["calculate", "test"],
        [("#Given", ["realTestGiven t_t"]),
         ("#Find", ["realTestFind s_s"])],
        Rule_Set.empty, NONE, [["Test", "test_calculate"]])]\<close>

partial_function (tailrec) calc_test :: "real \<Rightarrow> real"
  where
"calc_test t_t =
  (Repeat
    ((Try (Repeat (Calculate ''PLUS''))) #>
     (Try (Repeat (Calculate ''TIMES''))) #>
     (Try (Repeat (Calculate ''DIVIDE''))) #>
     (Try (Repeat (Calculate ''POWER''))))) t_t"
setup \<open>KEStore_Elems.add_mets @{context}
  [MethodC.prep_input (@{theory "Test"}) "met_testcal" [] MethodC.id_empty
      (["Test", "test_calculate"],
        [("#Given" , ["realTestGiven t_t"]), ("#Find", ["realTestFind s_s"])],
        {rew_ord'="sqrt_right",rls'=tval_rls,srls = Rule_Set.empty, prls = Rule_Set.empty,
          calc=[("PLUS", (\<^const_name>\<open>plus\<close>, eval_binop "#add_")),
              ("TIMES", (\<^const_name>\<open>times\<close>, eval_binop "#mult_")),
              ("DIVIDE", (\<^const_name>\<open>divide\<close>, Prog_Expr.eval_cancel "#divide_")),
              ("POWER", (\<^const_name>\<open>realpow\<close>, eval_binop "#power_"))],
          crls=tval_rls, errpats = [], nrls= Rule_Set.empty (*, asm_rls=[],asm_thm=[]*)},
        @{thm calc_test.simps})]
\<close>

ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close>
end
